import React, { Component } from 'react';
import { connect } from 'react-redux';
import { Redirect } from 'react-router';
import { SubmissionError } from 'redux-form';
import FormularioFactura from './FormularioFactura';
import {
  buscarFacturaPorId,
  actualizarFactura
} from '../../actions/AccionesFacturas';

class EditarFactura extends Component {
  state = {
    redirect: false
  };

  componentDidMount() {
    const { id } = this.props.match.params;

    if (id) {
      this.props.buscarFacturaPorId(id);
    }
  }

  submit = factura => {
    return this.props
      .actualizarFactura(factura)
      .then(response => this.setState({ redirect: true }))
      .catch(err => {
        throw new SubmissionError(this.props.errores);
      });
  };

  render() {
    return (
      <div>
        <h2>Editar factura</h2>
        <div>
          {this.state.redirect ? (
            <Redirect to='/facturas' />
          ) : (
            <FormularioFactura
              factura={this.props.factura}
              cargando={this.props.cargando}
              onSubmit={this.submit}
            />
          )}
        </div>
      </div>
    );
  }
}

function mapStateToProps(state) {
  return {
    factura: state.facturasDs.factura,
    cargando: state.facturasDs.cargando,
    errores: state.facturasDs.errores
  };
}

export default connect(
  mapStateToProps,
  { buscarFacturaPorId, actualizarFactura }
)(EditarFactura);
