import React, { Component } from 'react';
import { connect } from 'react-redux';
import { buscarClientes, eliminarCliente } from '../../actions';
import { Link } from 'react-router-dom';

class ListarCliente extends Component {
  componentDidMount() {
    this.props.buscarClientes();
  }

  crearFilas() {
    return this.props.listaClientes.map(cliente => {
      return (
        <tr key={cliente._id}>
          <td>{cliente.nombre}</td>
          <td>{cliente.email}</td>
          <td>{cliente.cuil}</td>
          <td>{cliente.telefono}</td>
          <td>{cliente.direccion}<tr key={cliente.direccion._id}>
          <td>{cliente.direccion.calle}</td>
                <td>{cliente.direccion.numero}</td>
                <td>{cliente.direccion.piso}</td>
                <td>{cliente.direccion.departamento}</td>
          
          </tr></td>
          <td>
            <Link to={`/clientes/${cliente._id}/ver`} className='mr-2'>
              Ver
            </Link>
            <Link to={`/clientes/${cliente._id}/editar`} className='mr-2'>
              Editar
            </Link>
            <a
              className='mr-2'
              href='#more'
              onClick={() => {
                if (
                  window.confirm(
                    '¿Está usted seguro que desea eliminar el Cliente?'
                  )
                )
                  this.props.eliminarCliente(cliente._id);
              }}
            >
              Eliminar
            </a>
          </td>
        </tr>
      );
    });
  }

  render() {
    return (
      <div>
        <h2>Listando Clientes</h2>

        <p>
          <Link to='/clientes/nuevo' className='btn btn-primary'>
            Nuevo
          </Link>
        </p>

        <div className='table-responsive'>
          <table className='table table-striped table-sm'>
            <thead>
              <tr>
                <th>Nombre</th>
                <th>Email</th>
                <th>Cuil</th>
                <th>Telefono</th>
                <th>Direccion</th>
                <th>Acciones</th>
              </tr>
            </thead>
            <tbody>{this.crearFilas()}</tbody>
          </table>
        </div>
      </div>
    );
  }
}

function mapState(state) {
  return {
    listaClientes: state.clientesDs.listaClientes
  };
}

const actions = {
  buscarClientes,
  eliminarCliente
};

export default connect(
  mapState,
  actions
)(ListarCliente);
