import React, { Component } from 'react';
import { connect } from 'react-redux';
import { buscarFacturas, eliminarFactura} from '../../actions';
import { Link } from 'react-router-dom';

class ListarFactura extends Component {
  componentDidMount() {
    this.props.buscarFacturas();
  }


  crearFilas() {
    return this.props.listaFacturas.map(factura => {
      return (
        <tr key={factura._id}>
          <td>{factura.numero}</td>
          <td>{factura.fecha}</td>
          <td>{factura.tipo}</td>
          <td>{factura.sucursal}</td>
          <td>{factura.cliente}<tr key={factura.cliente._id}>
            <td>{factura.cliente.nombre}</td>
            <td>{factura.cliente.email}</td>
            <td>{factura.cliente.cuil}</td>
            <td>{factura.cliente.telefono}</td>
            <td>{factura.cliente.direccion}<tr>
                <tr key={factura.cliente.direccion._id}>
                <td>{factura.cliente.direccion.calle}</td>
                <td>{factura.cliente.direccion.numero}</td>
                <td>{factura.cliente.direccion.piso}</td>
                <td>{factura.cliente.direccion.departamento}</td>
                </tr>
              </tr></td>
          </tr></td>
          <td>{factura.detalle.map((d,index) =>{
            <tr key={index}>
              <td>{d.cantidad}</td>
              <td><tr key= {d.producto._id}>
              <td>{d.producto.codigo}</td>
              <td>{d.producto.nombre}</td>
              <td>{d.producto.precio}</td> 
              </tr>
              </td>
              <td>{d.subtotal}</td>
            
            </tr>
          
          })}</td>
          <td>{factura.total}</td>
          <td>
            <Link to={`/facturas/${factura._id}/ver`} className='mr-2'>
              Ver
            </Link>
            <Link to={`/facturas/${factura._id}/editar`} className='mr-2'>
              Editar
            </Link>
            <a
              className='mr-2'
              href='#more'
              onClick={() => {
                if (
                  window.confirm(
                    '¿Está usted seguro que desea eliminar la factura?'
                  )
                )
                  this.props.eliminarFactura(factura._id);
              }}
            >
              Eliminar
            </a>
          </td>
        </tr>
      );
    });
  }

  render() {
    return (
      <div>
        <h2>Listando Facturas</h2>

        <p>
          <Link to='/facturas/nueva' className='btn btn-primary'>
            Nuevo
          </Link>
        </p>

        <div className='table-responsive'>
          <table className='table table-striped table-sm'>
            <thead>
              <tr>
                <th>Numero</th>
                <th>Fecha</th>
                <th>Tipo</th>
                <th>Sucursal</th>
                <th>Cliente</th>
                <th>Detalle</th>
                <th>Total</th>
                <th>Acciones</th>
              </tr>
            </thead>
            <tbody>{this.crearFilas()}</tbody>
          </table>
        </div>
      </div>
    );
  }
}

function mapState(state) {
  return {
    listaFacturas: state.facturassDs.listaFacturas
  };
}

const actions = {
  buscarFacturas,
  eliminarFactura
};

export default connect(
  mapState,
  actions
)(ListarFactura);
