import React, { Component } from 'react';
import { connect } from 'react-redux';
import { buscarFacturaPorId } from '../../actions/AccionesFacturas';
import { Link } from 'react-router-dom';

class VerFactura extends Component {
  componentDidMount() {
    const { id } = this.props.match.params;
    this.id = id;
    if (id) {
      this.props.buscarFacturaPorId(id);
    }
  }

  render() {
    return (
      <div>
        <h2>Ver Factura</h2>

        <br />

        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Numero:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.numero}</div>
        </div>

        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Fecha:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.fecha}</div>
        </div>

        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Tipo:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.tipo}</div>
        </div>
        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Sucursal:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.sucursal}</div>
        </div>
        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Cliente:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.cliente}</div>
        </div>
        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Detalle:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.detalle.map((d,index)=>{
            <tr key={index}>
            <td>Cantidad: {this.props.d.cantidad}</td>
            <td>
              <tr key={d.producto._id}> Producto:
              <td>Codigo: {this.props.d.producto.codigo}</td>
              <td>Nombre: {this.props.d.producto.nombre}</td>
              <td>Precio: {this.props.d.producto.precio}</td>
            </tr></td>
            <td>Subtotal: {this.props.d.subtotal}</td>
            </tr>
          })}</div>
        </div>
        <div className='row'>
          <div className='col-sm-2'>
            <p className='font-weight-bold text-right'>Total:</p>
          </div>
          <div className='col-sm-10'>{this.props.factura.total}</div>
        </div>
    


        <div className='row'>
          <Link className='btn btn-light mr-2' to='/facturas'>
            Volver
          </Link>
          <Link
            to={`/facturas/${this.id}/editar`}
            className='btn btn-secondary mr-2'
          >
            Editar
          </Link>
          &nbsp;
        </div>
      </div>
    );
  }
}

function mapState(state) {
  return {
    factura: state.facturasDs.factura
  };
}

const actions = {
  buscarFacturaPorId
};

export default connect(
  mapState,
  actions
)(VerFactura);
